
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SQL Server 性能调优4 之书写高效的查询 / 憋错料</title>

    <meta name="description" content="SQL Server 性能调优4 之书写高效的查询 限制查询的行和列来提高性能 这条规则非常简单,这里就不细说了. 使用搜索可参数化判断(sargable conditions)来提高性能 Sargable 由 Search ARGument Able 简写而来,字面意思是搜索可参数化?还是比较晦涩哎... 总之使用Sargable判断可以帮助查询优化器更有效地利用索引,并提高采用 index seek 的可能性,我们先把所有的操作符分一下组. Sargable操作符 = &gt; &gt;= &lt; &lt;= BETWEEN LIKE (通 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">SQL Server 性能调优4 之书写高效的查询</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>限制查询的行和列来提高性能</h2>
<p>这条规则非常简单，这里就不细说了。</p>
<h2>使用搜索可参数化判断(sargable&nbsp;conditions)来提高性能</h2>
<p>Sargable 由&nbsp;Search ARGument Able 简写而来，字面意思是搜索可参数化？还是比较晦涩哎...</p>
<p>总之使用Sargable判断可以帮助查询优化器更有效地利用索引，并提高采用&nbsp;index seek 的可能性，我们先把所有的操作符分一下组。</p>
<ul>
<li>Sargable操作符</p>
<ul>
<li>=</li>
<li>&gt;</li>
<li>&gt;=</li>
<li>&lt;</li>
<li>&lt;=</li>
<li>BETWEEN</li>
<li>LIKE (通配符必须出现在最后，比如‘R%’)</li>
</ul>
</li>
</ul>
<ul>
<li>非Sargable操作符</p>
<ul>
<li>!=</li>
<li>!&gt;</li>
<li>!&lt;</li>
<li>&lt;&gt;</li>
<li>NOT EXISTS</li>
<li>IN</li>
<li>NOT IN</li>
<li>BETWEEN</li>
<li>LIKE (通配符出现在前面，比如‘%R‘)</li>
<li>NOT LIKE</li>
<li>针对某列的函数</li>
</ul>
</li>
</ul>
<p>知道了这些你就可以在允许的场合下尽量使用Sargable操作（譬如用多个 OR 来替代 IN）</p>
<h2>在判定中巧妙地利用计算操作来提高性能</h2>
<p>WHERE 子句中针对列的计算操作会导致非Sargable，间接导致列上的索引无法被有效利用，所以应当尽量避免。不幸的是没有什么自动方法来帮助你找到这些地方，你必须手工检查查询脚本并利用性能工具来定位问题所在。</p>
<p>我们用&nbsp;AdventureWorks2012 数据库中的两张表来做个例子：</p>
<ul>
<li>[AdventureWorks2012].[HumanResources].[Employee]</li>
<li>[AdventureWorks2012].[HumanResources].[EmployeePayHistory]</li>
</ul>
<p>我们第一个查询抽出&nbsp;Employee 表的基本信息，并取得对应的 EmployeePayHistory 表中最新的数据，并且满足&nbsp;HourlyRate*8&lt;=152</p>
<pre>SELECT
  E.LoginID
  ,E.JobTitle
  ,E.BirthDate
  ,E.MaritalStatus
  ,E.Gender
  ,E.HireDate
  ,EP.HourlyRate
  ,EP.RateChangeDate
FROM [AdventureWorks2012].[HumanResources].[Employee] AS E
JOIN
(
  Select
    Max(BusinessEntityID) AS BusinessEntityID
    ,Max(RateChangeDate) AS RateChangeDate
    ,Rate AS HourlyRate
  FROM
    [AdventureWorks2012].[HumanResources].[EmployeePayHistory]
  GROUP BY
    Rate
) as EP
ON E.BusinessEntityID=EP.BusinessEntityID
WHERE EP.HourlyRate*8&lt;=152</pre>
<p>上面的查询在 WHERE 中进行&lt;=判断前对列进行了一次数字计算（*8），该列上的索引就无法起效了。</p>
<p>对&nbsp;WHERE 子句稍作修改，就可避免这个问题：</p>
<pre>..
..
WHERE EP.HourlyRate&lt;=152/8</pre>
<p>修改后在 &lt;= 判断前没有对列进行操作，所以列上的索引会起效。看一下前后的性能指标：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MDgxMDMxNTg2MjU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YzNGc1kyaGxiZz09L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>前一个查询占用了53%的开销，后一个占用了47%，两者相差数量级虽然不是非常大，但是随着表数据的增加，差异将逐渐扩大。</p>
<h2>不在判定中对列进行函数操作来提高性能</h2>
<p>与前一段的原理一样，WHERE 子句中针对列的函数操作会导致“非Sargable”，导致性能下降。这里就不重复举例了。</p>
<h2>利用定义参照的完整性来改善性能</h2>
<p>定义参照的完整性 （Declarative Referential Integrity），简称 DRI，指利用主键和外键来保证数据库的完整性/一致性。</p>
<p>经常遇到这样的情况：开发者在主表中建立了主键，并用这个主键到子表中去取关联数据，但却没有在子表中建立外键。实际上建立外键不但能帮助你保证数据库的完整性/一致性，还能提高查询关联数据时的性能，我们用一个示例来验证这个说法：</p>
<p>1. 我们新建两张表</p>
<pre>IF OBJECT_ID(&#039;ProductDemo&#039;) IS NOT NULL
  DROP TABLE ProductDemo
GO
IF OBJECT_ID(&#039;ProductModelDemo&#039;) IS NOT NULL
  DROP TABLE ProductModelDemo
GO
select * into ProductModelDemo from Production.ProductModel
select * into ProductDemo from Production.Product WHERE ProductModelID is not null
GO</pre>
<p>2. 在子表&nbsp;ProductDemo 上声明&nbsp;ProductModelID 为非空字段，并建立为主键</p>
<pre>ALTER TABLE ProductDemo
ALTER COLUMN ProductModelID INT NOT NULL
GO

ALTER TABLE ProductDemo ADD CONSTRAINT [PK_ProductDemo_ProductID]
PRIMARY KEY CLUSTERED
(
  [ProductID] ASC
)
GO</pre>
<p>3. 在主表 ProductModelDemo:&nbsp;上建立主键</p>
<pre>ALTER TABLE ProductModelDemo ADD CONSTRAINT [PK_ProductModelDemo_
ProductModelID] PRIMARY KEY CLUSTERED
(
  ProductModelID ASC
)
GO</pre>
<p>4. 执行测试查询</p>
<pre>SELECT
  P.ProductID
  ,P.ProductModelID
FROM
  ProductDemo AS P
JOIN
  ProductModelDemo AS PM
ON
  P.ProductModelID=PM.ProductModelID
WHERE
  P.ProductID=680
GO</pre>
<p>执行计划如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MDgxMDMzMDc5MDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YzNGc1kyaGxiZz09L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>5. 建立子父之间的外间关联</p>
<pre>ALTER TABLE ProductDemo
WITH CHECK
ADD CONSTRAINT
  FK_ProductDemo_ProductModelDemo_ProductModelID
FOREIGN KEY
  (ProductModelID)
REFERENCES
  ProductModelDemo(ProductModelID)
GO</pre>
<p>再次执行第4步的查询，执行计划如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MDgxMDMzMTMwNjI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YzNGc1kyaGxiZz09L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>修改后的查询只需要在&nbsp;ProductDemo 表上执行一次索引检索。</p>
<p>在外键字段上定义 NOT NULL，保证了子表中的数据必在父表中存在关联信息，优化器从而“信任”该子表（在不检索父表数据的情况下，不需要再去访问/检查父表）。</p>
<h2>“信任”外键来获取性能改进</h2>
<p>使用&nbsp;sys.foreign_keys 系统视图能获取外键的信息，is_not_trusted 字段表示该外键是否被“信任”。</p>
<p>要建立被“信任”的外键可以在创建脚本中使用 WITH CHECK 参数，具体可参照前文的脚本。</p>
<h2>备注</h2>
<p>最后再添加几点：</p>
<ul>
<li>尽可能多的指定查询筛选条件</li>
<li>可以不用 ORDER BY 尽量不用</li>
<li>GROUP BY 子句中的项目尽可能少，并尽可能取自同一个表</li>
<li>GROUP BY 子句中尽量用数字类型的字段，避免用文本</li>
<li>GROUP BY 和 ORDER BY 中的字段尽量取自同一个表</li>
</ul>
<p><P><A href="http://www.bubuko.com/infodetail-248467.html" rel="external nofollow noreferrer">SQL Server 性能调优4 之书写高效的查询,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-09 13:35:58 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.biecuoliao.com/tag/%e4%bc%98%e5%8c%96/" title="优化">优化</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>SQL Server 性能调优4 之书写高效的查询的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6lDKN3.html" rel="bookmark">SQL Server 性能调优3 之索引（Index）的维护</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SQL Server 性能调优3 之索引(Index)的维护 热度1 评论 16 作者:溪溪水草 前言 前一篇的文章介绍了通过建立索引来提高数据库的查询性能,这其实只是个开始.后续如果缺少适当的维护,你先前建立的索引甚至会成为拖累,成为数据库性能的下降的帮凶. 查找碎片 消除碎片可能是索引维护最常规的任务,微软官方给出的建议是当碎片等级为 5% - 30% 之间时采用 REORGANIZE 来“重整”索引,如果达到 30% 以上则使用 REBUILD 来“重建”索引.决定采用何种手段和操作时机可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGAbga3.html" rel="bookmark">SQL Server 性能调优培训引言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server 性能调优培训引言 大家好,这是我在博客园写的第一篇博文,之所以要开这个博客,是我对MS SQL技术学习的一个兴趣记录. 作为计算机专业毕业的人,自己对技术的掌握总是觉得很肤浅,博而不专,到现在我才发现自己的兴趣所在,于是我通过网络找了各种MS SQL技术的相关文档,总觉得讲得比较干涩,没有一个系统性,今年3月底我无意浏览到一个网站提供免费的性能调优的半年培训(http://www.sqlpassion.at/academy/performance-tuning-tra			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZQQRq0.html" rel="bookmark">SQL Server 性能调优（一）&mdash;&mdash;从等待状态判断系统资源瓶颈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server 性能调优(一)--从等待状态判断系统资源瓶颈 通过DMV查看当时SQL SERVER所有任务的状态(sleeping.runnable或running) 2005.2008提供了以下三个视图工详细查询: DMV 用处 Sys.dm_exec_requests 返回有关在SQL Server中执行的每个请求的信息,包括当前的等待状态 Sys.dm_exec_sessions 对于每个通过身份验证的会话都返回相应的一行.此时图是服务器范围的视图.此视图首先可以查到服务器负			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyzlEm0.html" rel="bookmark">SQL Server 性能调优2 之索引（Index）的建立</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 索引是关系数据库中最重要的对象之一,他能显著减少磁盘I/O及逻辑读取的消耗,并以此来提升 SELECT 语句的查找性能.但它是一把双刃剑,使用不当反而会影响性能:他需要额外的控件来存放这些索引信息,并且当数据更新时需要一些额外开销来保持索引的同步. 形象的来说索引就像字典里的目录,你要查找某一个字的时候可以根据它的比划/拼音先在目录中找到对应的页码范围,然后在该范围中找到这个字.如果没有这个目录(索引),你可能需要翻遍整本字典来找到要找的字. SQL Server 中的索引以 B-Tree			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0krZRpM.html" rel="bookmark">SQL Server 性能调优 之执行计划（Execution Plan）调优</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				执行计划中的三种 Join 策略 SQL Server 存在三种 Join 策略:Hash Join,Merge Join,Nested Loop Join. Hash Join:用来处理没有排过序/没有索引的数据,它在内存中把 Join 两边数据(的关联key)分别建立一个哈希表.例如有以下的查询语句,关联的两张表没有建立索引,执行计划将显示为Hash Join. SELECT sh.* FROM SalesOrdHeaderDemo AS sh JOIN SalesOrdDetailDemo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02dBXE4.html" rel="bookmark">sql server 性能调优 资源等待之 LCk</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.  概述 这次介绍实例级别资源等待LCK类型锁的等待时间,关于LCK锁的介绍可参考 &quot;sql server 锁与事务拨云见日&quot;.下面还是使用sys.dm_os_wait_stats 来查看,并找出耗时最高的LOK锁. select wait_type, waiting_tasks_count, wait_time_ms , max_wait_time_ms, signal_wait_time_ms from sys.dm_os_wait_stats where wait_type			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kvQalM.html" rel="bookmark">sql server 性能调优 资源等待之网络I&sol;O</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:sql server 性能调优 资源等待之网络I/O 一.概述 与网络I/O相关的等待的主要是ASYNC_NETWORK_IO,是指当sql server返回数据结果集给客户端的时候,会先将结果集填充到输出缓存里(ouput cache),同时网络层会开始将输出缓存里的数据打包,由客户端接收.如果客户端接收数据包慢,sql server没有地方存放新数据结果时,这时任务进入ASYNC_NETWORK_IO等待状态. 1. 从实例级别查看ASYNC_NETWORK_IO 平均耗时: 4636			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MonAVb4.html" rel="bookmark">sql server  性能调优之 SQL语句阻塞查询</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:sql server 性能调优之 SQL语句阻塞查询 在生产环境下,有时公司客服反映网页半天打不到,除了在浏览器按F12的Network响应来排查,确定web服务器无故障后.就需要检查数据库是否有出现阻塞 当时数据库的生产环境中主表数据量超过2000w,子表数据量超过1亿,且更新和新增频繁.再加上做了同步镜像,很消耗资源. 这时就要新建一个会话,大概需要了解以下几点: 1.当前活动会话量有多少? 2.会话运行时间? 3.会话之间有没有阻塞? 4.阻塞时间 ? 查询阻塞的方法有很多.有sql			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xjbVD4.html" rel="bookmark">sql server 性能调优之 逻辑内存消耗最大资源分析1 &lpar;自sqlserver服务启动以后&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:sql server 性能调优之 逻辑内存消耗最大资源分析1 (自sqlserver服务启动以后) 一.概述 IO 内存是sql server最重要的资源,数据从磁盘加载到内存,再从内存中缓存,输出到应用端,在sql server 内存初探中有介绍.在明白了sqlserver内存原理后,就能更好的分析I/O开销,从而提升数据库的整体性能. 在生产环境下数据库的sqlserver服务启动后一个星期,就可以通过dmv来分析优化.在I/O分析这块可以从物理I/O和内存I/O二方面来分析, 重点分			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/74QnOwM.html" rel="bookmark" class="title">前端学习&mdash;&mdash;css&lpar;初级&rpar;</a>
					<div>
						1.Css盒模型(box model) web开发中,html的每个元素都是盒子,盒子可以装内容(content).可以有填充物(padding).有外壳(border) 和 外保护层(margin) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYdwb0.html" rel="bookmark" class="title">jstl的自定义标签</a>
					<div>
						1)作用:当jsp的内置标签或者jstl不满足我们,这时需要自定义标签2)三个步骤:  需求: 使用自定义标签输出客户的ip地址SimpleTag接口的方法:doTag():执行标签的方法,由web服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYWLV0.html" rel="bookmark" class="title">规范化程序设计的实例（1）</a>
					<div>
						提出问题 首先要感谢实验室的章老师提出一个有现实应用的背景与问题: 智能手机中,用户十分关心已经使用的流量, 希望可以查看已经使用的网络流量: 本程 序主要实现过去 1 分钟以及过去 1 小时已经使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEEYA3.html" rel="bookmark" class="title">HQL（Hibernate Query Language）</a>
					<div>
						1. NativeSQL &gt; HQL &gt; EJB QL(JP QL 1.0) &gt; QBC(Query By Criteria) &gt; QBE(Query By Example)2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ZwNRM.html" rel="bookmark" class="title">使用ConcurrentLinkedQueue惨痛的教训【转】</a>
					<div>
						转自:http://blog.csdn.net/jackpk/article/details/49634577 服务端原本有个定时任务对一个集合ArrayList 中的消息做处理. 因为考虑到处理消息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8yJO3.html" rel="bookmark" class="title">洛谷P2731 骑马修栅栏 Riding the Fences</a>
					<div>
						P2731 骑马修栅栏 Riding the Fences• o 119通过o 468提交• 题目提供者该用户不存在• 标签USACO• 难度普及+/提高 提交 讨论 题解 最新讨论 • 数据有问题题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lrAqX4.html" rel="bookmark" class="title">细心很重要---猜猜这个SQL执行的什么意思</a>
					<div>
						今天在帮客户做语句优化的时候,突然遇到这样一个语句,类似下面的例子(原语句是个update) 例子中使用AdventureWorks数据中的两个表. productID 是[Production].[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX77qQ4.html" rel="bookmark" class="title">算法导论学习笔记&mdash;&mdash;第4章</a>
					<div>
						解递归式 1.代换法substitution 1)猜测解的形式 2)用数学归纳法找出使解真正有效的常数 2.递归树 使用递归树时,可以忽略一些“小误差”,将递归产生的结果作为猜测,用代换法进行验证.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYk6mM.html" rel="bookmark" class="title">LoaderManager使用详解（四）---实例：AppListLoader</a>
					<div>
						实例:AppListLoader 这篇文章将是我的第四篇,也就是最后一篇该系列的文章.请在评论里面告诉我他们是否有用.前面几篇文章的链接如下: 一:Loaders之前世界 二:了解LoaderMana ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YYy6X0.html" rel="bookmark" class="title">规范化和集合了几个方法符合他很有风格</a>
					<div>
						http://gz.58.com/jdyd/jh_%E8%B5%B5%E5%8E%BF%E6%89%BE%E5%B0%8F%E5%A7%90%E4%B8%8A%E9%97%A8%E6%9C%8D%E5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLW6XA4.html" rel="bookmark" class="title">设置tnsnames&period;ora将其间的一段设置成自个的实践情况</a>
					<div>
						假如要使用PLSQL东西来衔接数据库.'couriernew',courier,宋体,monospace;WHITE-SPA CE:pre-wrap;PA DDING-BOTTOM:0px;PA DD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qv6yz4.html" rel="bookmark" class="title">Java 中 volatile 关键字的使用注意点</a>
					<div>
						锁提供了两种主要特性:互斥(mutual exclusion) 和可见性(visibility).互斥即一次只允许一个线程持有某个特定的锁,因此可使用该特性实现对共享数据的协调访问协议,这样,一次就只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvnyp3.html" rel="bookmark" class="title">vfptr&lpar;1&rpar;</a>
					<div>
						前言 C++中的虚函数的作用主要是实现了多态的机制.关于多态,简而言之就是用父类型别的指针指向其子类的实例,然后通过父类的指针调用实际子类的成员函数.这种技术可以让父类的指针有“多种形态”,这是一种泛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1OPW4.html" rel="bookmark" class="title">uva 1658 Admiral （最小费最大流）</a>
					<div>
						uva 1658 Admiral 题目大意:在图中找出两条没有交集的线路,要求这两条线路的费用最小. 解题思路:还是拆点建图的问题. 首先每一个点都要拆成两个点.比如a点拆成a-&gt;a'.起点和终 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0leVPZ3.html" rel="bookmark" class="title">D - Periodic Strings&lpar;UVA-455&rpar;</a>
					<div>
						A character string is said to have period k if it can be formed by concatenating one or more repetit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6z7BNM.html" rel="bookmark" class="title">&amp;quot&semi;ORA-12154&colon; TNS&colon;could not resolve the connect identifier specified&amp;quot&semi;的解决办法</a>
					<div>
						添加环境变量解决: 变量名:TNS_ADMIN 变量值:D:\Ocl\product\11.2.0\dbhome_1\NETWORK\ADMIN tnsnames.ora所在的路径					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvOAy3.html" rel="bookmark" class="title">&lbrack;Stanford&rsqb; RPN Calculator&lpar;model improved version&rpar;</a>
					<div>
						以前的model是把操作数压入栈里,遇到加减乘除号直接计算结果,改进版的是把操作数和加减乘除号都压入栈里,controller里的接口不变: CalculatorBrain.h #import &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02yEoBM.html" rel="bookmark" class="title">来自方程的空间曲线&lowbar;2&lpar;空间正玄波--笛卡尔坐标）</a>
					<div>
						在空间正玄波--球坐标的第三步位置,选择笛卡尔坐标系,添加方程: x = 4 * cos(360*t) y = 4 * sin(360*t) z = 2 * cos(360 * t * 5)   // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6jny0.html" rel="bookmark" class="title">每天一个Linux命令（22）--find命令详解</a>
					<div>
						find 一些常用参数的一些常用实例和一些具体用法和注意事项. 1.使用 name 选项: 文件名选项是 find 命令最常用的选项,要么单独使用该选项,要么和其他选项一起使用. 可以使用某种文件名模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02wQJD3.html" rel="bookmark" class="title">SVN库迁移整理方法总结</a>
					<div>
						有时候需要从一台机器迁移svn存储库到另外一台机器,如果数据量非常大的话,没有好的方法是很不方便的,其实迁移svn跟迁移mysql差不多,也有导出导入的方案 以下是subversion官方推荐的备份方 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
